From e799a1a3e17aaae2e2076ce43bf2f7a4fa162b69 Mon Sep 17 00:00:00 2001
From: Dominik Bartkiewicz <bart@schedmd.com>
Date: Wed, 4 May 2022 13:06:36 -0600
Subject: [PATCH 01/14] Prevent credential abuse.

CVE-2022-29500
---
 NEWS                                          |   1 +
 src/api/config_info.c                         |   1 +
 src/api/job_info.c                            |   2 +
 src/api/job_step_info.c                       |   2 +
 src/api/node_info.c                           |   1 +
 src/api/pmi_server.c                          |   1 +
 src/api/reconfigure.c                         |   1 +
 src/api/signal.c                              |   3 +
 src/api/slurm_pmi.c                           |   3 +
 src/api/step_launch.c                         |   2 +
 src/bcast/file_bcast.c                        |   1 +
 src/common/forward.c                          |   5 +-
 src/common/slurm_auth.c                       |  43 +-
 src/common/slurm_auth.h                       |  16 +-
 src/common/slurm_persist_conn.c               |   1 +
 src/common/slurm_persist_conn.h               |   1 +
 src/common/slurm_protocol_api.c               | 243 ++++++++++-
 src/common/slurm_protocol_api.h               |   3 +
 src/common/slurm_protocol_defs.c              |   4 +
 src/common/slurm_protocol_defs.h              |  14 +
 src/common/slurmdb_defs.c                     |   1 +
 src/common/stepd_api.c                        |   3 +-
 src/common/stepd_api.h                        |   3 +-
 .../accounting_storage/common/common_as.c     |   1 +
 .../accounting_storage/slurmdbd/dbd_conn.c    | 380 ++++++++++++++++++
 src/plugins/auth/jwt/auth_jwt.c               |  16 +-
 src/plugins/auth/munge/auth_munge.c           |  49 ++-
 src/plugins/auth/none/auth_none.c             |  17 +-
 src/plugins/mpi/pmi2/setup.c                  |   2 +
 src/plugins/mpi/pmi2/setup.h                  |   1 +
 src/plugins/mpi/pmi2/spawn.c                  |   4 +-
 src/plugins/mpi/pmix/pmixp_dconn.c            |   1 +
 src/plugins/mpi/pmix/pmixp_dconn.h            |   3 +
 src/plugins/mpi/pmix/pmixp_server.c           |  27 +-
 src/plugins/mpi/pmix/pmixp_utils.c            |   1 +
 src/sattach/sattach.c                         |   1 +
 src/slurmctld/agent.c                         |  23 +-
 src/slurmctld/agent.h                         |   5 +
 src/slurmctld/backup.c                        |   9 +-
 src/slurmctld/controller.c                    |   2 +
 src/slurmctld/fed_mgr.c                       |   2 +
 src/slurmctld/job_mgr.c                       |  14 +-
 src/slurmctld/job_scheduler.c                 |   3 +
 src/slurmctld/node_mgr.c                      |   3 +
 src/slurmctld/node_scheduler.c                |   3 +
 src/slurmctld/ping_nodes.c                    |   4 +
 src/slurmctld/proc_req.c                      |   2 +
 src/slurmctld/srun_comm.c                     |  37 +-
 src/slurmctld/step_mgr.c                      |   3 +
 src/slurmd/slurmd/req.c                       |  21 +-
 src/slurmd/slurmd/slurmd.c                    |   6 +-
 src/slurmd/slurmstepd/io.c                    |   1 +
 src/slurmd/slurmstepd/mgr.c                   |  16 +-
 src/slurmd/slurmstepd/mgr.h                   |   2 +-
 src/slurmd/slurmstepd/req.c                   |   1 +
 src/slurmd/slurmstepd/slurmstepd.c            |  23 +-
 src/slurmd/slurmstepd/slurmstepd_job.c        |   7 +-
 src/slurmd/slurmstepd/slurmstepd_job.h        |   4 +-
 src/slurmd/slurmstepd/x11_forwarding.c        |   4 +
 src/slurmdbd/read_config.c                    |   1 +
 src/slurmdbd/slurmdbd.c                       |   1 +
 61 files changed, 988 insertions(+), 67 deletions(-)
 create mode 100644 src/plugins/accounting_storage/slurmdbd/dbd_conn.c

diff --git a/NEWS b/NEWS
index 4ed7678514..3340c918a7 100644
--- a/NEWS
+++ b/NEWS
@@ -1,6 +1,7 @@
 This file describes changes in recent versions of Slurm. It primarily
 documents those changes that are of interest to users and administrators.
 
+ -- CVE-2022-29500 - Prevent credential abuse.
  -- CVE-2022-29501 - Prevent abuse of REQUEST_FORWARD_DATA.
 
 * Changes in Slurm 20.02.7
diff --git a/src/api/config_info.c b/src/api/config_info.c
index f8c9f08dcb..0f2a373b44 100644
--- a/src/api/config_info.c
+++ b/src/api/config_info.c
@@ -1911,6 +1911,7 @@ slurm_load_slurmd_status(slurmd_status_t **slurmd_status_ptr)
 	}
 	req_msg.msg_type = REQUEST_DAEMON_STATUS;
 	req_msg.data     = NULL;
+	slurm_msg_set_r_uid(&req_msg, SLURM_AUTH_UID_ANY);
 
 	rc = slurm_send_recv_node_msg(&req_msg, &resp_msg, 0);
 
diff --git a/src/api/job_info.c b/src/api/job_info.c
index 5d47db0f82..412e5eb059 100644
--- a/src/api/job_info.c
+++ b/src/api/job_info.c
@@ -1500,6 +1500,7 @@ slurm_pid2jobid (pid_t job_pid, uint32_t *jobid)
 	req.job_pid      = job_pid;
 	req_msg.msg_type = REQUEST_JOB_ID;
 	req_msg.data     = &req;
+	slurm_msg_set_r_uid(&req_msg, SLURM_AUTH_UID_ANY);
 
 	rc = slurm_send_recv_node_msg(&req_msg, &resp_msg, 0);
 
@@ -1875,6 +1876,7 @@ slurm_network_callerid (network_callerid_msg_t req, uint32_t *job_id,
 
 	req_msg.msg_type = REQUEST_NETWORK_CALLERID;
 	req_msg.data     = &req;
+	slurm_msg_set_r_uid(&req_msg, SLURM_AUTH_UID_ANY);
 
 	if (slurm_send_recv_node_msg(&req_msg, &resp_msg, 0) < 0)
 		return SLURM_ERROR;
diff --git a/src/api/job_step_info.c b/src/api/job_step_info.c
index c53aa51e9d..ebe406a1c1 100644
--- a/src/api/job_step_info.c
+++ b/src/api/job_step_info.c
@@ -605,6 +605,7 @@ extern int slurm_job_step_stat(uint32_t job_id, uint32_t step_id,
 	      __func__, job_id, step_id, node_list);
 
 	slurm_msg_t_init(&req_msg);
+	slurm_msg_set_r_uid(&req_msg, SLURM_AUTH_UID_ANY);
 
 	memset(&req, 0, sizeof(req));
 	resp_out->job_id = req.job_id = job_id;
@@ -720,6 +721,7 @@ extern int slurm_job_step_get_pids(uint32_t job_id, uint32_t step_id,
 	      __func__, job_id, step_id, node_list);
 
 	slurm_msg_t_init(&req_msg);
+	slurm_msg_set_r_uid(&req_msg, SLURM_AUTH_UID_ANY);
 
 	memset(&req, 0, sizeof(req));
 	resp_out->job_id = req.job_id = job_id;
diff --git a/src/api/node_info.c b/src/api/node_info.c
index 8f9cb0e26e..22dbeb13fa 100644
--- a/src/api/node_info.c
+++ b/src/api/node_info.c
@@ -859,6 +859,7 @@ extern int slurm_get_node_energy(char *host, uint16_t context_id,
 	req.delta        = delta;
 	req_msg.msg_type = REQUEST_ACCT_GATHER_ENERGY;
 	req_msg.data     = &req;
+	slurm_msg_set_r_uid(&req_msg, SLURM_AUTH_UID_ANY);
 
 	rc = slurm_send_recv_node_msg(&req_msg, &resp_msg, 0);
 
diff --git a/src/api/pmi_server.c b/src/api/pmi_server.c
index 203bf0504f..520eea944f 100644
--- a/src/api/pmi_server.c
+++ b/src/api/pmi_server.c
@@ -141,6 +141,7 @@ static void *_msg_thread(void *x)
 	slurm_msg_t msg_send;
 
 	slurm_msg_t_init(&msg_send);
+	slurm_msg_set_r_uid(&msg_send, SLURM_AUTH_UID_ANY);
 
 	debug2("KVS_Barrier msg to %s:%hu",
 		msg_arg_ptr->bar_ptr->hostname,
diff --git a/src/api/reconfigure.c b/src/api/reconfigure.c
index fd428c36d0..789a060777 100644
--- a/src/api/reconfigure.c
+++ b/src/api/reconfigure.c
@@ -157,6 +157,7 @@ static int _send_message_controller(int dest, slurm_msg_t *req)
 		slurm_seterrno_ret(SLURMCTLD_COMMUNICATIONS_CONNECTION_ERROR);
 	}
 
+	slurm_msg_set_r_uid(req, slurm_conf.slurm_user_id);
 	if (slurm_send_node_msg(fd, req) < 0) {
 		close(fd);
 		slurm_seterrno_ret(SLURMCTLD_COMMUNICATIONS_SEND_ERROR);
diff --git a/src/api/signal.c b/src/api/signal.c
index 8f585db6a3..bd536e97f4 100644
--- a/src/api/signal.c
+++ b/src/api/signal.c
@@ -59,6 +59,7 @@ static int _local_send_recv_rc_msgs(const char *nodelist,
 	slurm_msg_t *msg = xmalloc(sizeof(slurm_msg_t));
 
 	slurm_msg_t_init(msg);
+	slurm_msg_set_r_uid(msg, SLURM_AUTH_UID_ANY);
 	msg->msg_type = type;
 	msg->data = data;
 
@@ -101,6 +102,7 @@ static int _signal_batch_script_step(const resource_allocation_response_msg_t
 	rpc.flags = KILL_JOB_BATCH;
 
 	slurm_msg_t_init(&msg);
+	slurm_msg_set_r_uid(&msg, slurm_conf.slurmd_user_id);
 	msg.msg_type = REQUEST_SIGNAL_TASKS;
 	msg.data = &rpc;
 	if (slurm_conf_get_addr(name, &msg.address, msg.flags)
@@ -159,6 +161,7 @@ static int _terminate_batch_script_step(const resource_allocation_response_msg_t
 
 	slurm_msg_t_init(&msg);
 	msg.msg_type = REQUEST_TERMINATE_TASKS;
+	slurm_msg_set_r_uid(&msg, slurm_conf.slurmd_user_id);
 	msg.data = &rpc;
 
 	if (slurm_conf_get_addr(name, &msg.address, msg.flags)
diff --git a/src/api/slurm_pmi.c b/src/api/slurm_pmi.c
index c2c4dce054..4028105b26 100644
--- a/src/api/slurm_pmi.c
+++ b/src/api/slurm_pmi.c
@@ -178,6 +178,7 @@ int slurm_send_kvs_comm_set(kvs_comm_set_t *kvs_set_ptr,
 	_set_pmi_time();
 
 	slurm_msg_t_init(&msg_send);
+	slurm_msg_set_r_uid(&msg_send, SLURM_AUTH_UID_ANY);
 	msg_send.address = srun_addr;
 	msg_send.msg_type = PMI_KVS_PUT_REQ;
 	msg_send.data = (void *) kvs_set_ptr;
@@ -260,6 +261,7 @@ int  slurm_get_kvs_comm_set(kvs_comm_set_t **kvs_set_ptr,
 	data.port = port;
 	data.hostname = hostname;
 	slurm_msg_t_init(&msg_send);
+	slurm_msg_set_r_uid(&msg_send, SLURM_AUTH_UID_ANY);
 	slurm_msg_t_init(&msg_rcv);
 	msg_send.address = srun_addr;
 	msg_send.msg_type = PMI_KVS_GET_REQ;
@@ -344,6 +346,7 @@ static int _forward_comm_set(kvs_comm_set_t *kvs_set_ptr)
 		if (kvs_set_ptr->kvs_host_ptr[i].port == 0)
 			continue;	/* empty */
 		slurm_msg_t_init(&msg_send);
+		slurm_msg_set_r_uid(&msg_send, SLURM_AUTH_UID_ANY);
 		msg_send.msg_type = PMI_KVS_GET_RESP;
 		msg_send.data = (void *) kvs_set_ptr;
 		slurm_set_addr(&msg_send.address,
diff --git a/src/api/step_launch.c b/src/api/step_launch.c
index 09b441f084..c75f3dc403 100644
--- a/src/api/step_launch.c
+++ b/src/api/step_launch.c
@@ -900,6 +900,7 @@ extern void slurm_step_launch_fwd_signal(slurm_step_ctx_t *ctx, int signo)
 	hostlist_destroy(hl);
 
 RESEND:	slurm_msg_t_init(&req);
+	slurm_msg_set_r_uid(&req, SLURM_AUTH_UID_ANY);
 	req.msg_type = REQUEST_SIGNAL_TASKS;
 	req.data     = &msg;
 
@@ -1723,6 +1724,7 @@ static int _launch_tasks(slurm_step_ctx_t *ctx,
 	}
 
 	slurm_msg_t_init(&msg);
+	slurm_msg_set_r_uid(&msg, SLURM_AUTH_UID_ANY);
 	msg.msg_type = REQUEST_LAUNCH_TASKS;
 	msg.data = launch_msg;
 
diff --git a/src/bcast/file_bcast.c b/src/bcast/file_bcast.c
index 149a0ed3a1..0a1064704b 100644
--- a/src/bcast/file_bcast.c
+++ b/src/bcast/file_bcast.c
@@ -190,6 +190,7 @@ static int _file_bcast(struct bcast_parameters *params,
 	slurm_msg_t msg;
 
 	slurm_msg_t_init(&msg);
+	slurm_msg_set_r_uid(&msg, SLURM_AUTH_UID_ANY);
 	msg.data = bcast_msg;
 	msg.flags = USE_BCAST_NETWORK;
 	msg.forward.tree_width = params->fanout;
diff --git a/src/common/forward.c b/src/common/forward.c
index bdcfe09c74..eaf6ceb62a 100644
--- a/src/common/forward.c
+++ b/src/common/forward.c
@@ -248,7 +248,7 @@ void *_forward_thread(void *arg)
 			/*      steps, fwd_msg->timeout); */
 		}
 
-		ret_list = slurm_receive_msgs(fd, steps, fwd_msg->timeout);
+		ret_list = slurm_receive_resp_msgs(fd, steps, fwd_msg->timeout);
 		/* info("sent %d forwards got %d back", */
 		/*      fwd_msg->header.forward.cnt, list_count(ret_list)); */
 
@@ -357,6 +357,9 @@ void *_fwd_tree_thread(void *arg)
 	send_msg.flags = fwd_tree->orig_msg->flags;
 	send_msg.data = fwd_tree->orig_msg->data;
 	send_msg.protocol_version = fwd_tree->orig_msg->protocol_version;
+	if (fwd_tree->orig_msg->restrict_uid_set)
+		slurm_msg_set_r_uid(&send_msg,
+				    fwd_tree->orig_msg->restrict_uid);
 
 	/* repeat until we are sure the message was sent */
 	while ((name = hostlist_shift(fwd_tree->tree_hl))) {
diff --git a/src/common/slurm_auth.c b/src/common/slurm_auth.c
index 69e5c4de3e..f9431b209c 100644
--- a/src/common/slurm_auth.c
+++ b/src/common/slurm_auth.c
@@ -62,12 +62,16 @@ typedef struct {
 typedef struct {
 	uint32_t	(*plugin_id);
 	char		(*plugin_type);
-	void *		(*create)	(char *auth_info);
+	bool		(*hash_enable);
+	void *		(*create)	(char *auth_info, uid_t r_uid,
+					 void *data, int dlen);
 	int		(*destroy)	(void *cred);
 	int		(*verify)	(void *cred, char *auth_info);
 	uid_t		(*get_uid)	(void *cred);
 	gid_t		(*get_gid)	(void *cred);
 	char *		(*get_host)	(void *cred);
+	int		(*get_data)	(void *cred, char **data,
+					 uint32_t *len);
 	int		(*pack)		(void *cred, Buf buf,
 					 uint16_t protocol_version);
 	void *		(*unpack)	(Buf buf, uint16_t protocol_version);
@@ -82,12 +86,14 @@ typedef struct {
 static const char *syms[] = {
 	"plugin_id",
 	"plugin_type",
+	"hash_enable",
 	"slurm_auth_create",
 	"slurm_auth_destroy",
 	"slurm_auth_verify",
 	"slurm_auth_get_uid",
 	"slurm_auth_get_gid",
 	"slurm_auth_get_host",
+	"auth_p_get_data",
 	"slurm_auth_pack",
 	"slurm_auth_unpack",
 	"slurm_auth_thread_config",
@@ -95,6 +101,17 @@ static const char *syms[] = {
 	"slurm_auth_token_generate",
 };
 
+typedef struct {
+	int plugin_id;
+	char *type;
+} auth_plugin_types_t;
+
+auth_plugin_types_t auth_plugin_types[] = {
+	{ AUTH_PLUGIN_NONE, "auth/none" },
+	{ AUTH_PLUGIN_MUNGE, "auth/munge" },
+	{ AUTH_PLUGIN_JWT, "auth/jwt" },
+};
+
 /*
  * A global authentication context.  "Global" in the sense that there's
  * only one, with static bindings.  We don't export it.
@@ -104,6 +121,15 @@ static plugin_context_t **g_context = NULL;
 static int g_context_num = -1;
 static pthread_mutex_t context_lock = PTHREAD_MUTEX_INITIALIZER;
 
+extern bool slurm_get_plugin_hash_enable(int index)
+{
+	if (slurm_auth_init(NULL) < 0)
+		return true;
+
+	return *(ops[index].hash_enable);
+
+}
+
 extern int slurm_auth_init(char *auth_type)
 {
 	int retval = SLURM_SUCCESS;
@@ -232,14 +258,15 @@ int slurm_auth_index(void *cred)
  * the API function dispatcher.
  */
 
-void *g_slurm_auth_create(int index, char *auth_info)
+void *g_slurm_auth_create(int index, char *auth_info, uid_t r_uid,
+			  void *data, int dlen)
 {
 	cred_wrapper_t *cred;
 
 	if (slurm_auth_init(NULL) < 0)
 		return NULL;
 
-	cred = (*(ops[index].create))(auth_info);
+	cred = (*(ops[index].create))(auth_info, r_uid, data, dlen);
 	if (cred)
 		cred->index = index;
 	return cred;
@@ -295,6 +322,16 @@ char *g_slurm_auth_get_host(void *cred)
 	return (*(ops[wrap->index].get_host))(cred);
 }
 
+int auth_g_get_data(void *cred, char **data, uint32_t *len)
+{
+	cred_wrapper_t *wrap = (cred_wrapper_t *) cred;
+
+	if (!wrap || slurm_auth_init(NULL) < 0)
+		return SLURM_ERROR;
+
+	return (*(ops[wrap->index].get_data))(cred, data, len);
+}
+
 int g_slurm_auth_pack(void *cred, Buf buf, uint16_t protocol_version)
 {
 	cred_wrapper_t *wrap = (cred_wrapper_t *) cred;
diff --git a/src/common/slurm_auth.h b/src/common/slurm_auth.h
index 8a607a5b3c..7b6ca17cf8 100644
--- a/src/common/slurm_auth.h
+++ b/src/common/slurm_auth.h
@@ -63,6 +63,12 @@
  */
 #define SLURM_AUTH_NOBODY 99
 
+/*
+ * This should be equal to MUNGE_UID_ANY
+ * do not restrict decode via uid
+ */
+#define SLURM_AUTH_UID_ANY -1
+
 /*
  * Default auth_index value, corresponds to the primary AuthType used.
  */
@@ -86,15 +92,23 @@ extern int slurm_auth_fini(void);
  */
 extern int slurm_auth_index(void *cred);
 
+/*
+ * Check if plugin type corresponding to the authentication
+ * plugin index supports hash.
+ */
+extern bool slurm_get_plugin_hash_enable(int index);
+
 /*
  * Static bindings for the global authentication context.
  */
-extern void *g_slurm_auth_create(int index, char *auth_info);
+extern void *g_slurm_auth_create(int index, char *auth_info, uid_t r_uid,
+				 void *data, int dlen);
 extern int g_slurm_auth_destroy(void *cred);
 extern int g_slurm_auth_verify(void *cred, char *auth_info);
 extern uid_t g_slurm_auth_get_uid(void *cred);
 extern gid_t g_slurm_auth_get_gid(void *cred);
 extern char *g_slurm_auth_get_host(void *cred);
+extern int auth_g_get_data(void *cred, char **data, uint32_t *len);
 extern int g_slurm_auth_pack(void *cred, Buf buf, uint16_t protocol_version);
 extern void *g_slurm_auth_unpack(Buf buf, uint16_t protocol_version);
 
diff --git a/src/common/slurm_persist_conn.c b/src/common/slurm_persist_conn.c
index bb1a0bccbd..82b9d204a2 100644
--- a/src/common/slurm_persist_conn.c
+++ b/src/common/slurm_persist_conn.c
@@ -600,6 +600,7 @@ extern int slurm_persist_conn_open(slurm_persist_conn_t *persist_conn)
 	req_msg.flags |= SLURM_GLOBAL_AUTH_KEY;
 	if (persist_conn->flags & PERSIST_FLAG_DBD)
 		req_msg.flags |= SLURMDBD_CONNECTION;
+	slurm_msg_set_r_uid(&req_msg, persist_conn->r_uid);
 
 	memset(&req, 0, sizeof(persist_init_req_msg_t));
 	req.cluster_name = persist_conn->cluster_name;
diff --git a/src/common/slurm_persist_conn.h b/src/common/slurm_persist_conn.h
index 405a393d58..a8bfcba2c9 100644
--- a/src/common/slurm_persist_conn.h
+++ b/src/common/slurm_persist_conn.h
@@ -74,6 +74,7 @@ typedef struct {
 	uint16_t flags;
 	bool inited;
 	persist_conn_type_t persist_type;
+	uid_t r_uid;
 	char *rem_host;
 	uint16_t rem_port;
 	time_t *shutdown;
diff --git a/src/common/slurm_protocol_api.c b/src/common/slurm_protocol_api.c
index 5eb87d7b3f..c0aa1fd2ec 100644
--- a/src/common/slurm_protocol_api.c
+++ b/src/common/slurm_protocol_api.c
@@ -980,6 +980,36 @@ char *slurm_get_prep_plugins(void)
 	return plugins;
 }
 
+static int _check_hash(buf_t *buffer, header_t *header, slurm_msg_t *msg,
+		       void *cred)
+{
+	char *cred_hash = NULL;
+	uint32_t cred_hash_len = 0;
+	int rc;
+	static time_t config_update = (time_t) -1;
+	static bool block_null_hash = true;
+
+	if (config_update != slurm_conf.last_update) {
+		block_null_hash = (xstrcasestr(slurm_conf.comm_params,
+					       "block_null_hash"));
+		config_update = slurm_conf.last_update;
+	}
+
+	rc = auth_g_get_data(cred, &cred_hash, &cred_hash_len);
+
+	if (cred_hash || cred_hash_len) {
+		if (cred_hash_len != 3 || cred_hash[0] != 1 ||
+		    memcmp(cred_hash + 1,
+			   &msg->msg_type, sizeof(msg->msg_type)))
+			rc = SLURM_ERROR;
+	} else if (block_null_hash &&
+		   slurm_get_plugin_hash_enable(msg->auth_index))
+		rc = SLURM_ERROR;
+
+	xfree(cred_hash);
+	return rc;
+}
+
 static int _get_tres_id(char *type, char *name)
 {
 	slurmdb_tres_rec_t tres_rec;
@@ -3435,6 +3465,9 @@ extern int slurm_unpack_received_msg(slurm_msg_t *msg, int fd, Buf buffer)
 		goto total_return;
 	}
 
+	msg->auth_uid = g_slurm_auth_get_uid(auth_cred);
+	msg->auth_uid_set = true;
+
 	/*
 	 * Unpack message body
 	 */
@@ -3445,6 +3478,7 @@ extern int slurm_unpack_received_msg(slurm_msg_t *msg, int fd, Buf buffer)
 	msg->body_offset =  get_buf_offset(buffer);
 
 	if ((header.body_length > remaining_buf(buffer)) ||
+	    _check_hash(buffer, &header, msg, auth_cred) ||
 	    (unpack_msg(msg, buffer) != SLURM_SUCCESS)) {
 		rc = ESLURM_PROTOCOL_INCOMPLETE_PACKET;
 		(void) g_slurm_auth_destroy(auth_cred);
@@ -3548,6 +3582,8 @@ int slurm_receive_msg(int fd, slurm_msg_t *msg, int timeout)
 	 */
 	if (slurm_msg_recvfrom_timeout(fd, &buf, &buflen, 0, timeout) < 0) {
 		rc = errno;
+		if (!rc)
+			rc = SLURMCTLD_COMMUNICATIONS_RECEIVE_ERROR;
 		goto endit;
 	}
 
@@ -3710,6 +3746,8 @@ List slurm_receive_msgs(int fd, int steps, int timeout)
 		goto total_return;
 	}
 
+	msg.auth_uid = g_slurm_auth_get_uid(auth_cred);
+	msg.auth_uid_set = true;
 	/*
 	 * Unpack message body
 	 */
@@ -3718,6 +3756,7 @@ List slurm_receive_msgs(int fd, int steps, int timeout)
 	msg.flags = header.flags;
 
 	if ((header.body_length > remaining_buf(buffer)) ||
+	    _check_hash(buffer, &header, &msg, auth_cred) ||
 	    (unpack_msg(&msg, buffer) != SLURM_SUCCESS)) {
 		(void) g_slurm_auth_destroy(auth_cred);
 		free_buf(buffer);
@@ -3759,6 +3798,155 @@ total_return:
 
 }
 
+List slurm_receive_resp_msgs(int fd, int steps, int timeout)
+{
+	char *buf = NULL;
+	size_t buflen = 0;
+	header_t header;
+	int rc;
+	void *auth_cred = NULL;
+	slurm_msg_t msg;
+	buf_t *buffer;
+	ret_data_info_t *ret_data_info = NULL;
+	List ret_list = NULL;
+	int orig_timeout = timeout;
+
+	xassert(fd >= 0);
+
+	slurm_msg_t_init(&msg);
+	msg.conn_fd = fd;
+
+	if (timeout <= 0) {
+		/* convert secs to msec */
+		timeout = slurm_conf.msg_timeout * 1000;
+		orig_timeout = timeout;
+	}
+	if (steps) {
+		if (message_timeout < 0)
+			message_timeout = slurm_conf.msg_timeout * 1000;
+		orig_timeout = (timeout -
+				(message_timeout*(steps-1)))/steps;
+		steps--;
+	}
+
+	log_flag(NET, "%s: orig_timeout was %d we have %d steps and a timeout of %d",
+		 __func__, orig_timeout, steps, timeout);
+	/* we compare to the orig_timeout here because that is really
+	 *  what we are going to wait for each step
+	 */
+	if (orig_timeout >= (slurm_conf.msg_timeout * 10000)) {
+		log_flag(NET, "%s: Sending a message with timeout's greater than %d seconds, requested timeout is %d seconds",
+			 __func__, (slurm_conf.msg_timeout * 10),
+			 (timeout/1000));
+	} else if (orig_timeout < 1000) {
+		log_flag(NET, "%s: Sending a message with a very short timeout of %d milliseconds each step in the tree has %d milliseconds",
+			 __func__, timeout, orig_timeout);
+	}
+
+
+	/*
+	 * Receive a msg. slurm_msg_recvfrom() will read the message
+	 *  length and allocate space on the heap for a buffer containing
+	 *  the message.
+	 */
+	if (slurm_msg_recvfrom_timeout(fd, &buf, &buflen, 0, timeout) < 0) {
+		forward_init(&header.forward);
+		rc = errno;
+		goto total_return;
+	}
+
+	log_flag_hex(NET_RAW, buf, buflen, "%s: read", __func__);
+	buffer = create_buf(buf, buflen);
+
+	if (unpack_header(&header, buffer) == SLURM_ERROR) {
+		free_buf(buffer);
+		rc = SLURM_COMMUNICATIONS_RECEIVE_ERROR;
+		goto total_return;
+	}
+
+	if (check_header_version(&header) < 0) {
+		slurm_addr_t resp_addr;
+		if (!slurm_get_peer_addr(fd, &resp_addr)) {
+			error("%s: Invalid Protocol Version %u from at %pA",
+			      __func__, header.version, &resp_addr);
+		} else {
+			error("%s: Invalid Protocol Version %u from problem connection: %m",
+			      __func__, header.version);
+		}
+
+		free_buf(buffer);
+		rc = SLURM_PROTOCOL_VERSION_ERROR;
+		goto total_return;
+	}
+	//info("ret_cnt = %d",header.ret_cnt);
+	if (header.ret_cnt > 0) {
+		if (header.ret_list)
+			ret_list = header.ret_list;
+		else
+			ret_list = list_create(destroy_data_info);
+		header.ret_cnt = 0;
+		header.ret_list = NULL;
+	}
+
+	/* Forward message to other nodes */
+	if (header.forward.cnt > 0) {
+		error("%s: We need to forward this to other nodes use slurm_receive_msg_and_forward instead",
+		      __func__);
+	}
+
+	if (!(auth_cred = g_slurm_auth_unpack(buffer, header.version))) {
+		error("%s: auth_g_unpack: %m", __func__);
+		free_buf(buffer);
+		rc = ESLURM_PROTOCOL_INCOMPLETE_PACKET;
+		goto total_return;
+	}
+	g_slurm_auth_destroy(auth_cred);
+	/*
+	 * Unpack message body
+	 */
+	msg.protocol_version = header.version;
+	msg.msg_type = header.msg_type;
+	msg.flags = header.flags;
+
+	if ((header.body_length > remaining_buf(buffer)) ||
+	    (unpack_msg(&msg, buffer) != SLURM_SUCCESS)) {
+		free_buf(buffer);
+		rc = ESLURM_PROTOCOL_INCOMPLETE_PACKET;
+		goto total_return;
+	}
+	free_buf(buffer);
+	rc = SLURM_SUCCESS;
+
+total_return:
+	destroy_forward(&header.forward);
+
+	if (rc != SLURM_SUCCESS) {
+		if (ret_list) {
+			ret_data_info = xmalloc(sizeof(ret_data_info_t));
+			ret_data_info->err = rc;
+			ret_data_info->type = RESPONSE_FORWARD_FAILED;
+			ret_data_info->data = NULL;
+			list_push(ret_list, ret_data_info);
+		}
+
+		error("%s: failed: %s",
+		      __func__, slurm_strerror(rc));
+		usleep(10000);	/* Discourage brute force attack */
+	} else {
+		if (!ret_list)
+			ret_list = list_create(destroy_data_info);
+		ret_data_info = xmalloc(sizeof(ret_data_info_t));
+		ret_data_info->err = rc;
+		ret_data_info->node_name = NULL;
+		ret_data_info->type = msg.msg_type;
+		ret_data_info->data = msg.data;
+		list_push(ret_list, ret_data_info);
+	}
+
+	errno = rc;
+	return ret_list;
+
+}
 /* try to determine the UID associated with a message with different
  * message header version, return -1 if we can't tell */
 static int _unpack_msg_uid(Buf buffer, uint16_t protocol_version)
@@ -3946,6 +4134,9 @@ int slurm_receive_msg_and_forward(int fd, slurm_addr_t *orig_addr,
 		goto total_return;
 	}
 
+	msg->auth_uid = g_slurm_auth_get_uid(auth_cred);
+	msg->auth_uid_set = true;
+
 	/*
 	 * Unpack message body
 	 */
@@ -3960,6 +4151,7 @@ int slurm_receive_msg_and_forward(int fd, slurm_addr_t *orig_addr,
 	}
 
 	if ( (header.body_length > remaining_buf(buffer)) ||
+	    _check_hash(buffer, &header, msg, auth_cred) ||
 	     (unpack_msg(msg, buffer) != SLURM_SUCCESS) ) {
 		(void) g_slurm_auth_destroy(auth_cred);
 		free_buf(buffer);
@@ -4027,6 +4219,7 @@ int slurm_send_node_msg(int fd, slurm_msg_t * msg)
 	int      rc;
 	void *   auth_cred;
 	time_t   start_time = time(NULL);
+	unsigned char auth_payload[3] = { 1 }; /* uint8_t + uint16_t (msg_type) */
 
 	if (msg->conn) {
 		persist_msg_t persist_msg;
@@ -4062,6 +4255,9 @@ int slurm_send_node_msg(int fd, slurm_msg_t * msg)
 		return rc;
 	}
 
+	if (!msg->restrict_uid_set)
+		fatal("%s: restrict_uid is not set", __func__);
+	memcpy(auth_payload + 1, &msg->msg_type, sizeof(msg->msg_type));
 	/*
 	 * Initialize header with Auth credential and message type.
 	 * We get the credential now rather than later so the work can
@@ -4071,10 +4267,15 @@ int slurm_send_node_msg(int fd, slurm_msg_t * msg)
 	 */
 	if (msg->flags & SLURM_GLOBAL_AUTH_KEY) {
 		auth_cred = g_slurm_auth_create(msg->auth_index,
-						_global_auth_key());
+						_global_auth_key(),
+						msg->restrict_uid, auth_payload,
+						sizeof(auth_payload));
 	} else {
 		char *auth_info = slurm_get_auth_info();
-		auth_cred = g_slurm_auth_create(msg->auth_index, auth_info);
+		auth_cred = g_slurm_auth_create(msg->auth_index,
+						slurm_conf.authinfo,
+						msg->restrict_uid, auth_payload,
+						sizeof(auth_payload));
 		xfree(auth_info);
 	}
 
@@ -4092,11 +4293,17 @@ int slurm_send_node_msg(int fd, slurm_msg_t * msg)
 		(void) g_slurm_auth_destroy(auth_cred);
 		if (msg->flags & SLURM_GLOBAL_AUTH_KEY) {
 			auth_cred = g_slurm_auth_create(msg->auth_index,
-							_global_auth_key());
+							_global_auth_key(),
+							msg->restrict_uid,
+							auth_payload,
+							sizeof(auth_payload));
 		} else {
 			char *auth_info = slurm_get_auth_info();
 			auth_cred = g_slurm_auth_create(msg->auth_index,
-							auth_info);
+							slurm_conf.authinfo,
+							msg->restrict_uid,
+							auth_payload,
+							sizeof(auth_payload));
 			xfree(auth_info);
 		}
 	}
@@ -4331,6 +4538,24 @@ static void _resp_msg_setup(slurm_msg_t *msg, slurm_msg_t *resp_msg,
 	resp_msg->protocol_version = msg->protocol_version;
 	resp_msg->ret_list = msg->ret_list;
 	resp_msg->orig_addr = msg->orig_addr;
+	/*
+	 * Extra sanity check. This should always be set. But if for some
+	 * reason it isn't, restrict the decode to avoid leaking an
+	 * unrestricted authentication token.
+	 *
+	 * Implicitly trust communications initiated by SlurmUser and
+	 * SlurmdUser. In future releases this won't matter - there's
+	 * no point packing an auth token on the reply as it isn't checked,
+	 * but we're stuck doing that on older protocol versions for
+	 * backwards-compatibility.
+	 */
+	if (!msg->auth_uid_set)
+		slurm_msg_set_r_uid(resp_msg, SLURM_AUTH_NOBODY);
+	else if ((msg->auth_uid != slurm_conf.slurm_user_id) &&
+		 (msg->auth_uid != slurm_conf.slurmd_user_id))
+		slurm_msg_set_r_uid(resp_msg, msg->auth_uid);
+	else
+		slurm_msg_set_r_uid(resp_msg, SLURM_AUTH_UID_ANY);
 }
 
 static void _rc_msg_setup(slurm_msg_t *msg, slurm_msg_t *resp_msg,
@@ -4612,6 +4837,7 @@ extern int slurm_send_recv_controller_msg(slurm_msg_t * request_msg,
 	forward_init(&request_msg->forward);
 	request_msg->ret_list = NULL;
 	request_msg->forward_struct = NULL;
+	slurm_msg_set_r_uid(request_msg, SLURM_AUTH_UID_ANY);
 
 tryagain:
 	retry = 1;
@@ -4740,6 +4966,8 @@ extern int slurm_send_only_controller_msg(slurm_msg_t *req,
 		goto cleanup;
 	}
 
+	slurm_msg_set_r_uid(req, slurm_conf.slurm_user_id);
+
 	if ((rc = slurm_send_node_msg(fd, req)) < 0) {
 		rc = SLURM_ERROR;
 	} else {
@@ -5131,6 +5359,12 @@ extern void slurm_free_msg(slurm_msg_t *msg)
 	}
 }
 
+extern void slurm_msg_set_r_uid(slurm_msg_t *msg, uid_t r_uid)
+{
+	msg->restrict_uid = r_uid;
+	msg->restrict_uid_set = true;
+}
+
 extern char *nodelist_nth_host(const char *nodelist, int inx)
 {
 	hostlist_t hl = hostlist_create(nodelist);
@@ -5329,6 +5563,7 @@ extern int slurm_forward_data(
 	req.len = len;
 	req.data = (char *)data;
 
+	slurm_msg_set_r_uid(&msg, SLURM_AUTH_UID_ANY);
 	msg.msg_type = REQUEST_FORWARD_DATA;
 	msg.data = &req;
 
diff --git a/src/common/slurm_protocol_api.h b/src/common/slurm_protocol_api.h
index cadaf0130c..34384e0bcc 100644
--- a/src/common/slurm_protocol_api.h
+++ b/src/common/slurm_protocol_api.h
@@ -1082,6 +1082,7 @@ int slurm_receive_msg(int fd, slurm_msg_t *msg, int timeout);
  *                errno set.
  */
 List slurm_receive_msgs(int fd, int steps, int timeout);
+List slurm_receive_resp_msgs(int fd, int steps, int timeout);
 
 /*
  *  Receive a slurm message on the open slurm descriptor "fd" waiting
@@ -1390,6 +1391,8 @@ extern int *set_span(int total, uint16_t tree_width);
 extern void slurm_free_msg_members(slurm_msg_t *msg);
 extern void slurm_free_msg(slurm_msg_t * msg);
 
+extern void slurm_msg_set_r_uid(slurm_msg_t *msg, uid_t r_uid);
+
 /* must free this memory with free not xfree */
 extern char *nodelist_nth_host(const char *nodelist, int inx);
 extern int nodelist_find(const char *nodelist, const char *name);
diff --git a/src/common/slurm_protocol_defs.c b/src/common/slurm_protocol_defs.c
index bd00716147..1bd4dcbf03 100644
--- a/src/common/slurm_protocol_defs.c
+++ b/src/common/slurm_protocol_defs.c
@@ -52,6 +52,7 @@
 #include "src/common/power.h"
 #include "src/common/slurm_accounting_storage.h"
 #include "src/common/slurm_acct_gather_energy.h"
+#include "src/common/slurm_auth.h"
 #include "src/common/slurm_cred.h"
 #include "src/common/slurm_ext_sensors.h"
 #include "src/common/slurm_jobacct_gather.h"
@@ -124,6 +125,7 @@ extern void slurm_msg_t_init(slurm_msg_t *msg)
 {
 	memset(msg, 0, sizeof(slurm_msg_t));
 
+	msg->auth_uid = SLURM_AUTH_NOBODY;
 	msg->conn_fd = -1;
 	msg->msg_type = NO_VAL16;
 	msg->protocol_version = NO_VAL16;
@@ -151,6 +153,8 @@ extern void slurm_msg_t_copy(slurm_msg_t *dest, slurm_msg_t *src)
 	dest->ret_list = src->ret_list;
 	dest->forward_struct = src->forward_struct;
 	dest->orig_addr.sin_addr.s_addr = 0;
+	if (src->auth_uid_set)
+		slurm_msg_set_r_uid(dest, src->auth_uid);
 	return;
 }
 
diff --git a/src/common/slurm_protocol_defs.h b/src/common/slurm_protocol_defs.h
index b5ead888ba..e9971bbfbd 100644
--- a/src/common/slurm_protocol_defs.h
+++ b/src/common/slurm_protocol_defs.h
@@ -59,6 +59,7 @@
 #include "src/common/job_options.h"
 #include "src/common/list.h"
 #include "src/common/macros.h"
+#include "src/common/slurm_auth.h"
 #include "src/common/slurm_cred.h"
 #include "src/common/slurm_protocol_common.h"
 #include "src/common/slurm_persist_conn.h"
@@ -493,6 +494,19 @@ typedef struct slurm_msg {
 				 * so that we'll respond with the same auth
 				 * plugin used to connect to us originally.
 				 */
+	uid_t auth_uid;		/* NEVER PACK. Authenticated uid from auth
+				 * credential. Only valid if auth_uid_set is
+				 * true. Set to SLURM_AUTH_NOBODY if not set
+				 * yet.
+				 */
+	bool auth_uid_set;	/* NEVER PACK. True when auth_uid has been set.
+				 * This is a safety measure against handling
+				 * a slurm_msg_t that has been xmalloc()'d but
+				 * slurm_msg_t_init() was not called since
+				 * auth_uid would be root.
+				 */
+	uid_t restrict_uid;
+	bool restrict_uid_set;
 	uint32_t body_offset; /* DON'T PACK: offset in buffer where body part of
 				 buffer starts. */
 	Buf buffer; /* DON't PACK! ptr to buffer that msg was unpacked from. */
